Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jdt.core
Interface IMethod

All Superinterfaces:
  IAdaptable, IJavaElement, IMember, IParent, ISourceManipulation, ISourceReference

public interface IMethod
extends IMember

Represents a method (or constructor) declared in a type.

This interface is not intended to be implemented by clients.

Field Summary

Fields inherited from interface org.eclipse.jdt.core.IJavaElement
`CLASS_FILE, COMPILATION_UNIT, FIELD, IMPORT_CONTAINER, IMPORT_DECLARATION, INITIALIZER, JAVA_MODEL, JAVA_PROJECT, LOCAL_VARIABLE, METHOD, PACKAGE_DECLARATION, PACKAGE_FRAGMENT, PACKAGE_FRAGMENT_ROOT, TYPE`

Method Summary
`String` | `getElementName()` Returns the simple name of this method.
`String[]` | `getExceptionTypes()` Returns the type signatures of the exceptions this method throws, in the order declared in the source.
`int` | `getNumberOfParameters()` Returns the number of parameters of this method.
`String[]` | `getParameterNames()` Returns the names of parameters in this method.
`String[]` | `getParameterTypes()` Returns the type signatures for the parameters of this method.
`String` | `getReturnType()` Returns the type signature of the return value of this method.
`String` | `getSignature()` Returns the signature of this method.
`String[]` | `getTypeParameterSignatures()` Returns the formal type parameter signatures for this method.
`boolean` | `isConstructor()` Returns whether this method is a constructor.
`boolean` | `isMainMethod()` Returns whether this method is a main method.
`boolean` | `isSimilar(IMethod method)` Returns whether this method is similar to the given method.

Methods inherited from interface org.eclipse.jdt.core.IMember
`getClassFile, getCompilationUnit, getDeclaringType, getFlags, getNameRange, getType, isBinary`

Methods inherited from interface org.eclipse.jdt.core.IJavaElement
`exists, getAncestor, getCorrespondingResource, getElementType, getHandleIdentifier, getJavaModel, getJavaProject, getOpenable, getParent, getPath, getPrimaryElement, getResource, getSchedulingRule, getUnderlyingResource, isReadOnly, isStructureKnown`

Methods inherited from interface org.eclipse.core.runtime.IAdaptable
`getAdapter`

Methods inherited from interface org.eclipse.jdt.core.ISourceReference
`exists, getSource, getSourceRange`

Methods inherited from interface org.eclipse.jdt.core.ISourceManipulation
`copy, delete, move, rename`

Methods inherited from interface org.eclipse.jdt.core.IParent
`getChildren, hasChildren`

Method Detail

### getElementName

    public String getElementName()

  Returns the simple name of this method. For a constructor, this returns the simple name of the declaring type. Note: This holds whether the constructor appears in a source or binary type (even though class files internally define constructor names to be `"<init>"`). For the class initialization methods in binary types, this returns the special name `"<clinit>"`. This is a handle-only method.

  Specified by:
    `getElementName` in interface `IJavaElement`
  Returns:
    the simple name of this method

### getExceptionTypes

    public String[] getExceptionTypes()
                               throws JavaModelException

  Returns the type signatures of the exceptions this method throws, in the order declared in the source. Returns an empty array if this method throws no exceptions.

  For example, a source method declaring `"throws IOException"`, would return the array `{"QIOException;"}`.

  The type signatures may be either unresolved (for source types) or resolved (for binary types), and either basic (for basic types) or rich (for parameterized types). See `Signature` for details.

  Returns:
    the type signatures of the exceptions this method throws, in the order declared in the source, an empty array if this method throws no exceptions
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.
  See Also:
    `Signature`

### getTypeParameterSignatures

    public String[] getTypeParameterSignatures()
                                        throws JavaModelException

  Returns the formal type parameter signatures for this method. Returns an empty array if this method has no formal type parameters.

  The formal type parameter signatures may be either unresolved (for source types) or resolved (for binary types). See `Signature` for details.

  Returns:
    the formal type parameter signatures of this method, in the order declared in the source, an empty array if none
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.
  Since:
    3.0
  See Also:
    `Signature`

### getNumberOfParameters

    public int getNumberOfParameters()

  Returns the number of parameters of this method. This is a handle-only method.

  Returns:
    the number of parameters of this method

### getParameterNames

    public String[] getParameterNames()
                               throws JavaModelException

  Returns the names of parameters in this method. For binary types, these names are invented as "arg"+i, where i starts at 1 (even if source is associated with the binary). Returns an empty array if this method has no parameters.

  For example, a method declared as `public void foo(String text, int length)` would return the array `{"text","length"}`.

  Returns:
    the names of parameters in this method, an empty array if this method has no parameters
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.

### getParameterTypes

    public String[] getParameterTypes()

  Returns the type signatures for the parameters of this method. Returns an empty array if this method has no parameters. This is a handle-only method.

  For example, a source method declared as `public void foo(String text, int length)` would return the array `{"QString;","I"}`.

  The type signatures may be either unresolved (for source types) or resolved (for binary types), and either basic (for basic types) or rich (for parameterized types). See `Signature` for details.

  Returns:
    the type signatures for the parameters of this method, an empty array if this method has no parameters
  See Also:
    `Signature`

### getReturnType

    public String getReturnType()
                         throws JavaModelException

  Returns the type signature of the return value of this method. For constructors, this returns the signature for void.

  For example, a source method declared as `public String getName()` would return `"QString;"`.

  The type signature may be either unresolved (for source types) or resolved (for binary types), and either basic (for basic types) or rich (for parameterized types). See `Signature` for details.

  Returns:
    the type signature of the return value of this method, void for constructors
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.
  See Also:
    `Signature`

### getSignature

    public String getSignature()
                        throws JavaModelException

  Returns the signature of this method. This includes the signatures for the parameter types and return type, but does not include the method name, exception types, or type parameters.

  For example, a source method declared as `public void foo(String text, int length)` would return `"(QString;I)V"`.

  The type signatures embedded in the method signature may be either unresolved (for source types) or resolved (for binary types), and either basic (for basic types) or rich (for parameterized types). See `Signature` for details.

  Returns:
    the signature of this method
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.
  See Also:
    `Signature`

### isConstructor

    public boolean isConstructor()
                          throws JavaModelException

  Returns whether this method is a constructor.

  Returns:
    true if this method is a constructor, false otherwise
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.

### isMainMethod

    public boolean isMainMethod()
                         throws JavaModelException

  Returns whether this method is a main method. It is a main method if:
  - its name is equal to `"main"`
  - its return type is `void`
  - it is `static` and `public`
  - it defines one parameter whose type's simple name is String[]

  Returns:
    true if this method is a main method, false otherwise
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource.
  Since:
    2.0

### isSimilar

    public boolean isSimilar(IMethod method)

  Returns whether this method is similar to the given method. Two methods are similar if:
  - their element names are equal
  - they have the same number of parameters
  - the simple names of their parameter types are equal
  This is a handle-only method.

  Parameters:
    `method` - the given method
  Returns:
    true if this method is similar to the given method.
  Since:
    2.0
  See Also:
    `Signature.getSimpleName(char[])`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) IBM Corp. and others 2000, 2004. All Rights Reserved.